library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
entity ricerca is
	port (rst, clk,nw: in std_logic;
	valore: in std_logic_vector(3 downto 0);
	fine,trovato: out std_logic;
	ris: out std_logic_vector(2 downto 0)
	);
end ricerca;

architecture beh of ricerca is
type memoria is array(0 to 7) of std_logic_vector(3 downto 0);
signal mem: memoria :=("0000","0001","0010","0011",
"1000","1001","1010","1011");
type stati is (idle,ric);
signal S: stati;
signal RicEn: std_logic;

begin
process(rst,clk)
begin
	if rst = '1' then S<= idle;
	elsif clk'event and clk='1' then
		if S= idle and nw='1' then
			S<= ric;
		else S<= idle;
	    end if;
	end if;
end process;

process(S)
begin
	if S=ric then RicEn <= '1';
	else RicEn <= '0';
	end if;
end process;
	
process(clk)
variable t: std_logic;
variable i: integer range 0 to 8;
begin
	if clk'event and clk='1' then
       if RicEn = '1' then
		   t:='0';
		   i:=0;
		   while i<=7 and t='0'  loop
		    if valore=mem(i) then 
			   t:= '1';
		    else i:= i+1;
		    end if;
		   end loop;
		   trovato <= t;
		   fine<= '1';
		   if t='1' then
			   ris<= conv_std_logic_vector(i,3);
		   end if;
	   else fine<= '0';
		   trovato<='0';
       end if;
	  end if;
 end process;
end beh;
